# Retrieve payment methods and currencies

Use the **getVendorPaymentMethodCurrencies** call to get the list of available payment methods with currencies and countries. `PaymentMethod` and `CountryCode` can be used to filter the result and will list all the countries where the payment method is available.

## Request parameters

<table><thead><tr><th width="155.3333740234375">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>sessionID</code></td><td><strong>Required (string)</strong><br>Output of the <strong>Login</strong> method.</td></tr><tr><td><code>CountryCode</code></td><td><strong>Optional (string)</strong><br>Country code.</td></tr><tr><td><code>PaymentMethod</code></td><td><strong>Optional (string)</strong><br>Payment method.</td></tr></tbody></table>

### Request sample

```php
<?php
declare(strict_types=1);
class Configuration
{
    public const MERCHANT_CODE = '';
    public const MERCHANT_KEY = '';
    public const URL = 'http://api.2checkout.com/rpc/6.0';
    public const ACTION = 'getVendorPaymentMethodCurrencies';
    public const ADDITIONAL_OPTIONS = null;

    //array or JSON
    public const PAYLOAD = <<<JSON
     ["WIRE", "FR"]
JSON;
}

class Client
{
    private const LOGIN_METHOD = 'login';
    private $calls = 1;
    private $sessionId;
    private function generateAuth(): array
    {
        $merchantCode = Configuration::MERCHANT_CODE;
        $key = Configuration::MERCHANT_KEY;
        $date = gmdate('Y-m-d H:i:s');
        $string = strlen($merchantCode) . $merchantCode . strlen($date) . $date;
        $hash = hash_hmac('md5', $string, $key);
        return compact('merchantCode', 'date', 'hash');
    }
    public function login(string $url)
    {
        $payload = $this->generateAuth();
        $response = $this->call($url, array_values($payload), self::LOGIN_METHOD);
        $this->sessionId = $response['result'];
    }
    public function call(
        string $url = Configuration::URL,
               $payload = Configuration::PAYLOAD,
        string $action = Configuration::ACTION
    ): ?array {
        if (empty($this->sessionId) && $action !== self::LOGIN_METHOD) {
            $this->login($url);
        }
        if(is_string($payload)) {
            $payload = json_decode($payload, true);
        }

        if (!empty($this->sessionId)) {
            if (is_array($payload)) {
                $payload = array_merge([$this->sessionId], $payload);
            } else {
                $payload = [$this->sessionId, $payload];
            }

        }
        $payload = array_filter($payload);

        $request = json_encode([
            'jsonrpc' => '2.0',
            'method' => $action,
            'params' => $payload,
            'id' => $this->calls++,
        ]);
        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_SSLVERSION, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Accept: application/json', 'Cookie: XDEBUG_SESSION=PHPSTORM'));
        curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
        $response = curl_exec($curl);
        if(empty($response)) {
            die('Server unavailable');
        }
        echo $response . '</br>';
        return json_decode($response, true);;
    }
}
$client = new Client();
$result = $client->call();
var_dump($result);
```

### Response sample <a href="#response-example" id="response-example"></a>

```php
[
    {
        "Currencies": [
            "EUR",
            "GBP",
            "RON",
            "USD"
        ],
        "Countries": [
            "RO",
            "RU",
            "RW",
            "LC",
            "WS",
            "SM",
            "ST",
            "SA",
        ],
        "BusinessCompany": "AVANGATE_BV",
        "HasRenewal": false,
        "PaymentType": "wire",
        "PaymentMethod": "WIRE",
        "AutofillSettings": null
    }
]
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/json-rpc-api-reference/json-rpc-api-6.0/api-requests/retrieve-payment-methods-and-currencies.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
